## odb-api 0.18.0

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_CURRENT_SOURCE_DIR}/ecbuild/cmake;${CMAKE_MODULE_PATH}" )
include( ecbuild_bundle )

project( odb_api_bundle C CXX )

ecbuild_bundle_initialize()
ecbuild_bundle( PROJECT ecbuild        STASH "ecsdk/ecbuild"      TAG 2.9.0 )
ecbuild_bundle( PROJECT eckit          STASH "ecsdk/eckit"        TAG 0.21.0 )
ecbuild_bundle( PROJECT metkit         STASH "ecsdk/metkit"       TAG 0.11.0 )
ecbuild_bundle( PROJECT odb_api        STASH "odb/odb_api"        TAG 0.18.0 )

if( ENABLE_ODB )
ecbuild_bundle( PROJECT odb            STASH "odb/odb"            TAG 1.0.10 )
ecbuild_bundle( PROJECT odb-tools      STASH "odb/odb-tools"      TAG 0.18.0 )
endif()

ecbuild_bundle_finalize()

=== ecbuild/share/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

# ecbuild_add_resources( TARGET ecbuild_share
#	SOURCE_PACK ecmwf_license_header.txt
#	DONT_PACK_DIRS ecbuild )

install( DIRECTORY ecbuild/toolchains DESTINATION ${INSTALL_DATA_DIR} )

=== eckit/src/apps/CMakeLists.txt ===
ecbuild_add_executable( TARGET      eckit_version
                        OUTPUT_NAME eckit-version
                        SOURCES     eckit-version.cc
                        LIBS        eckit )

ecbuild_add_executable( TARGET      syslog_server
                        OUTPUT_NAME syslog-server
                        SOURCES     syslog-server.cc
                        LIBS        eckit )

ecbuild_add_executable( TARGET      syslog_client
                        OUTPUT_NAME syslog-client
                        SOURCES     syslog-client.cc
                        LIBS        eckit )

=== eckit/src/eckit/CMakeLists.txt ===
### endianess

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
        set( ECKIT_BIG_ENDIAN    1 )
        set( ECKIT_LITTLE_ENDIAN 0 )
else()
        set( ECKIT_BIG_ENDIAN    0 )
        set( ECKIT_LITTLE_ENDIAN 1 )
endif()

set( ECKIT_BIG_ENDIAN    ${ECKIT_BIG_ENDIAN}    )
set( ECKIT_LITTLE_ENDIAN ${ECKIT_LITTLE_ENDIAN} )

### check support for DL library

check_include_files( dlfcn.h  ECKIT_HAVE_DLFCN_H )

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )
    check_c_source_compiles( "#define _GNU_SOURCE\n#include <dlfcn.h>\nint main(){ void* addr; Dl_info info; dladdr(addr, &info); }\n"
        ECKIT_HAVE_DLADDR )
cmake_pop_check_state()

### system headers and symbols tests for eckit config headers

check_symbol_exists( MAP_ANONYMOUS "sys/mman.h"  ECKIT_HAVE_MAP_ANONYMOUS )
check_symbol_exists( MAP_ANON      "sys/mman.h"  ECKIT_HAVE_MAP_ANON )
check_symbol_exists( funopen       "stdio.h"     ECKIT_HAVE_FUNOPEN )
check_symbol_exists( fsync         "unistd.h"    ECKIT_HAVE_FSYNC)
check_symbol_exists( fdatasync     "unistd.h"    ECKIT_HAVE_FDATASYNC)
check_symbol_exists( fmemopen      "stdio.h"     ECKIT_HAVE_FMEMOPEN )

check_c_source_compiles( "#define _GNU_SOURCE\n#include <stdio.h>\nint main(){ void* cookie; const char* mode; cookie_io_functions_t iof; FILE* fopencookie(void *cookie, const char *mode, cookie_io_functions_t iof); }"
    ECKIT_HAVE_FOPENCOOKIE )

check_c_source_compiles( "#include <unistd.h>\n#include <execinfo.h>\n int main(){ void ** buffer; int i = backtrace(buffer, 256); }\n"
    ECKIT_HAVE_EXECINFO_BACKTRACE )

check_cxx_source_compiles( "#include <cxxabi.h>\n int main() { char * type; int status; char * r = abi::__cxa_demangle(type, 0, 0, &status); }"
    ECKIT_HAVE_CXXABI_H )

check_cxx_source_compiles( "#include <iostream>\nint main(int argc, char* argv[]) { std::cout << __FUNCTION__ << std::endl; }"
    ECKIT_HAVE_FUNCTION_DEF )

check_c_source_compiles( "#include <time.h>\nint main(){ time_t now; time(&now); struct tm t; gmtime_r(&now,&t); }\n"
    ECKIT_HAVE_GMTIME_R )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; struct dirent **result; int i = readdir_r(dirp, entry, result); }\n"
    ECKIT_HAVE_READDIR_R )

check_c_source_compiles( "#include <sys/types.h>\n#include <dirent.h>\nint main(){ DIR *dirp; int i = dirfd(dirp); }\n"
    ECKIT_HAVE_DIRFD )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; if(entry->d_type) { dirp = 0; } }\n"
    ECKIT_HAVE_DIRENT_D_TYPE )

check_cxx_source_compiles( "int main() { __int128 i = 0; return 0;}"
    ECKIT_HAVE_CXX_INT_128 )

### config headers

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_config.h.in   eckit_config.h  )
configure_file( eckit_version.h.in  eckit_version.h )

install(FILES
			${CMAKE_CURRENT_BINARY_DIR}/eckit_config.h
			${CMAKE_CURRENT_BINARY_DIR}/eckit_version.h
		DESTINATION
			${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_version.cc.in  eckit_version.cc )

### eckit sources

list( APPEND eckit_srcs eckit.h eckit_version.cc )

list( APPEND eckit_container_srcs

container/BTree.h
container/BTree.cc
container/Trie.h
container/Trie.cc
container/BloomFilter.h
container/BloomFilter.cc

container/Cache.h
container/CacheLRU.h
container/CacheLRU.cc

container/CacheManager.h
container/CacheManager.cc
container/DenseMap.h
container/StatCollector.h
container/Recycler.h
container/ClassExtent.h
container/KDMemory.h
container/KDMapped.cc
container/KDMapped.h

container/KDTree.h
container/BSPTree.h

container/MappedArray.h
container/MappedArray.cc

container/SharedMemArray.h
container/SharedMemArray.cc

container/sptree/SPIterator.h
container/sptree/SPNode.h

container/sptree/SPNodeQueue.h
container/sptree/SPTree.h
container/sptree/SPValue.h
container/sptree/SPNodeInfo.h
container/sptree/SPMetadata.h

container/kdtree/KDNode.h
container/kdtree/KDNode.cc
container/kdtree/KDNode.cc

container/bsptree/BSPNode.h
container/bsptree/BSPNode.cc
container/bsptree/BSPHyperPlane.h


)

list( APPEND eckit_io_srcs
io/Length.h
io/Length.cc
io/DataHandle.h
io/DataHandle.cc
io/Select.h
io/Select.cc
io/CommandStream.h
io/CommandStream.cc
io/Offset.h
io/Offset.cc
io/DataBlob.h
io/DataBlob.cc
io/Buffer.cc
io/Buffer.h
io/SharedBuffer.cc
io/SharedBuffer.h
io/CircularBuffer.cc
io/CircularBuffer.h
io/BufferCache.h
io/BufferCache.cc
io/FileLocker.h
io/FileLocker.cc
io/FileLock.h
io/FileLock.cc
io/FilePool.h
io/FilePool.cc
io/ResizableBuffer.h
io/ResizableBuffer.cc
io/DblBuffer.h
io/DblBuffer.cc
io/HandleBuf.h
io/HandleBuf.cc
io/StdFile.h
io/StdFile.cc
io/StdPipe.h
io/StdPipe.cc
io/StdioBuf.h
io/StdioBuf.cc
io/FileBase.h
io/FileBase.cc
io/TransferWatcher.h
io/TransferWatcher.cc
io/MoverTransfer.h
io/MoverTransfer.cc
io/SockBuf.h
io/SockBuf.cc
io/AutoCloser.h
io/AIOHandle.h
io/AIOHandle.cc
io/AsyncHandle.h
io/AsyncHandle.cc
io/BitIO.h
io/BitIO.cc
io/Compress.h
io/Compress.cc
io/Base64.h
io/Base64.cc
io/SharedHandle.h
io/SharedHandle.cc
io/BufferedHandle.h
io/BufferedHandle.cc
io/MemoryHandle.h
io/MemoryHandle.cc
io/EmptyHandle.h
io/EmptyHandle.cc
io/FTPHandle.h
io/FTPHandle.cc
io/URLHandle.h
io/URLHandle.cc
io/EasyCURL.h
io/EasyCURL.cc
io/FileDescHandle.h
io/FileDescHandle.cc
io/FileHandle.h
io/FileHandle.cc
io/MarsFSHandle.h
io/MarsFSHandle.cc
io/MarsFSPartHandle.h
io/MarsFSPartHandle.cc
io/PartHandle.h
io/PartHandle.cc
io/MultiPartHandle.h
io/MultiPartHandle.cc
io/StatsHandle.h
io/StatsHandle.cc
io/MoverHandle.h
io/MoverHandle.cc
io/MultiHandle.h
io/MultiHandle.cc
io/PartFileHandle.h
io/PartFileHandle.cc
io/PipeHandle.h
io/PipeHandle.cc
io/StdFileHandle.h
io/StdFileHandle.cc
io/RawFileHandle.cc
io/RawFileHandle.h
io/TCPHandle.h
io/TCPHandle.cc
io/TCPSocketHandle.h
io/TCPSocketHandle.cc
io/TeeHandle.h
io/TeeHandle.cc
io/Pipeline.h
io/Pipeline.cc
io/HandleHolder.h
io/HandleHolder.cc
io/cluster/ClusterDisks.h
io/cluster/ClusterDisks.cc
io/cluster/ClusterNode.h
io/cluster/ClusterNode.cc
io/cluster/ClusterNodes.h
io/cluster/ClusterNodes.cc
io/cluster/NodeInfo.h
io/cluster/NodeInfo.cc )

list( APPEND eckit_filesystem_srcs
filesystem/FileSystemSize.h
filesystem/PathExpander.h
filesystem/PathExpander.cc
filesystem/PathName.h
filesystem/PathName.cc
filesystem/BasePathNameT.h
filesystem/BasePathNameT.cc
filesystem/BasePathName.cc
filesystem/BasePathName.h
filesystem/LocalPathName.h
filesystem/LocalPathName.cc
filesystem/FileSpace.h
filesystem/FileSpace.cc
filesystem/FileSpaceStrategies.h
filesystem/FileSpaceStrategies.cc
filesystem/FileSystem.h
filesystem/FileSystem.cc
filesystem/TempFile.h
filesystem/TempFile.cc
filesystem/TmpFile.h
filesystem/TmpFile.cc
filesystem/marsfs/MarsFSFile.h
filesystem/marsfs/MarsFSFile.cc
filesystem/marsfs/MarsFSPath.h
filesystem/marsfs/MarsFSPath.cc
filesystem/marsfs/MarsFSClient.h
filesystem/marsfs/MarsFSClient.cc
filesystem/URIManager.h
filesystem/URIManager.cc
filesystem/URI.h
filesystem/URI.cc )

list( APPEND eckit_thread_srcs
    thread/AutoLock.h
    thread/Mutex.cc
    thread/Mutex.h
    thread/MutexCond.cc
    thread/MutexCond.h
    thread/Once.h
    thread/StaticMutex.cc
    thread/StaticMutex.h
    thread/Thread.cc
    thread/Thread.h
    thread/ThreadControler.cc
    thread/ThreadControler.h
    thread/ThreadPool.cc
    thread/ThreadPool.h
    thread/ThreadSingleton.h
)

list( APPEND eckit_config_srcs
config/Configurable.cc
config/Configurable.h
config/Configuration.cc
config/Configuration.h
config/Configured.cc
config/Configured.h
config/EtcTable.cc
config/EtcTable.h
config/JSONConfiguration.h
config/LibEcKit.cc
config/LibEcKit.h
config/LocalConfiguration.cc
config/LocalConfiguration.h
config/Parametrisation.h
config/Resource.h
config/ResourceBase.h
config/ResourceBase.cc
config/ResourceMgr.cc
config/ResourceMgr.h
config/YAMLConfiguration.cc
config/YAMLConfiguration.h
)

list( APPEND eckit_runtime_srcs
runtime/Task.h
runtime/Task.cc
runtime/TaskID.h
runtime/Main.h
runtime/Main.cc
runtime/Application.h
runtime/Application.cc
runtime/Tool.h
runtime/Tool.cc
runtime/Library.h
runtime/Library.cc
runtime/Monitor.h
runtime/Monitor.cc
runtime/Monitorable.h
runtime/Monitorable.cc
runtime/TaskInfo.h
runtime/TaskInfo.cc
runtime/PipeApplication.h
runtime/PipeApplication.cc
runtime/PipeHandler.h
runtime/PipeHandler.cc
runtime/ProcessControler.h
runtime/ProcessControler.cc
runtime/Dispatcher.h
runtime/Pipe.h
runtime/ProducerConsumer.h )

list( APPEND eckit_log_srcs
log/BigNum.h
log/BigNum.cc
log/Bytes.h
log/Bytes.cc
log/CallbackTarget.h
log/CallbackTarget.cc
log/TimeStampTarget.h
log/TimeStampTarget.cc
log/PrefixTarget.h
log/PrefixTarget.cc
log/WrapperTarget.h
log/WrapperTarget.cc
log/IndentTarget.h
log/IndentTarget.cc
log/Channel.h
log/Channel.cc
log/OStreamTarget.h
log/OStreamTarget.cc
log/LineBasedTarget.h
log/LineBasedTarget.cc
log/TeeTarget.h
log/TeeTarget.cc
log/StatusTarget.h
log/StatusTarget.cc
log/MonitorTarget.h
log/MonitorTarget.cc
log/MessageTarget.h
log/MessageTarget.cc
log/ChannelBuffer.h
log/ChannelBuffer.cc
log/CodeLocation.h
log/CodeLocation.cc
log/ColouringTarget.h
log/ColouringTarget.cc
log/Colour.h
log/Colour.cc
log/ETA.h
log/ETA.cc
log/FileTarget.h
log/FileTarget.cc
log/Log.h
log/Log.cc
log/Plural.h
log/Progress.h
log/Progress.cc
log/RotationTarget.h
log/RotationTarget.cc
log/SavedStatus.h
log/SavedStatus.cc
log/Seconds.h
log/Seconds.cc
log/SysLog.h
log/SysLog.cc
log/Statistics.h
log/Statistics.cc
log/LogTarget.h
log/LogTarget.cc
log/ProgressTimer.h
log/ProgressTimer.cc
log/Timer.h
log/Timer.cc
log/TraceTimer.h
log/ResourceUsage.h
log/ResourceUsage.cc
log/TimeStamp.h
log/TimeStamp.cc
log/UserChannel.h
log/UserChannel.cc
)

list( APPEND eckit_exception_srcs
exception/Exceptions.h
exception/Exceptions.cc )

list( APPEND eckit_types_srcs
types/Types.h
types/Types.cc
types/Double.h
types/Double.cc
types/Fraction.h
types/Fraction.cc
types/FixedString.h
types/FloatCompare.h
types/FloatCompare.cc
types/ClimateDate.h
types/ClimateDate.cc
types/Coord.h
types/Coord.cc
types/DateTime.h
types/DateTime.cc
types/DayOfYear.h
types/DayOfYear.cc
types/Grid.h
types/Grid.cc
types/Metadata.h
types/Metadata.cc
types/Month.h
types/Month.cc
types/TimeInterval.h
types/TimeInterval.cc
types/Date.h
types/Date.cc
types/UUID.h
types/UUID.cc
types/Time.h
types/Time.cc
types/VerifyingDate.h
types/VerifyingDate.cc
)

list( APPEND eckit_parser_srcs
parser/StreamParser.h
parser/StreamParser.cc
parser/StringTools.h
parser/StringTools.cc
parser/Tokenizer.h
parser/Tokenizer.cc
parser/JSON.h
parser/JSON.cc
parser/ObjectParser.h
parser/ObjectParser.cc
parser/JSONParser.h
parser/JSONParser.cc
parser/YAMLParser.h
parser/YAMLParser.cc
parser/JSONDataBlob.h
parser/JSONDataBlob.cc
parser/JSONMetadata.h
parser/JSONMetadata.cc )

list( APPEND eckit_value_srcs
value/BoolContent.h
value/BoolContent.cc
value/CompositeParams.cc
value/CompositeParams.h
value/Content.h
value/Content.cc
value/DateContent.h
value/DateContent.cc
value/TimeContent.h
value/TimeContent.cc
value/DateTimeContent.h
value/DateTimeContent.cc
value/DispatchParams.h
value/DoubleContent.h
value/DoubleContent.cc
value/Expression.h
value/ListContent.h
value/ListContent.cc
value/MapContent.h
value/MapContent.cc
value/OrderedMapContent.h
value/OrderedMapContent.cc
value/NilContent.h
value/NilContent.cc
value/NumberContent.h
value/NumberContent.cc
value/Params.cc
value/Params.h
value/Properties.h
value/Properties.cc
value/ScopeParams.cc
value/ScopeParams.h
value/StringContent.h
value/StringContent.cc
value/Value.h
value/Value.cc )

list( APPEND eckit_os_srcs
os/Stat.h
os/System.h
os/System.cc
os/AutoUmask.h
os/SemLocker.h
os/SemLocker.cc
os/Semaphore.h
os/Semaphore.cc
os/SignalHandler.h
os/SignalHandler.cc
os/Password.h
os/Password.cc
os/BackTrace.h
os/BackTrace.cc
os/AutoAlarm.h
os/AutoAlarm.cc
os/SharedInt.h
os/SharedInt.cc )

list( APPEND eckit_net_srcs
net/TCPClient.h
net/TCPClient.cc
net/TCPSocket.h
net/TCPSocket.cc
net/TCPStream.h
net/TCPStream.cc
net/NetAddress.h

=== eckit/tests/filesystem/CMakeLists.txt ===
# aio system calls are know to fail on the Cray
# see https://sourceware.org/bugzilla/show_bug.cgi?id=11787

ecbuild_add_test( TARGET      eckit_test_filesystem_multihandle
                  SOURCES     test_multihandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_aiohandle
                  CONDITION   NOT DEFINED ENV{CRAYOS_VERSION}
                  SOURCES     test_aiohandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_asynchandle
                  SOURCES     test_asynchandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_atomic_file_update
                  SOURCES     test_atomic_file_update.cc
                  LIBS        eckit )


ecbuild_add_test( TARGET      eckit_test_filesystem_localpathname
                  SOURCES     test_localpathname.cc
                  LIBS        eckit )


ecbuild_add_test( TARGET      eckit_test_filesystem_restarthandle
                  SOURCES     test_restarthandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_pathexpander
                  SOURCES     test_pathexpander.cc
                  ENVIRONMENT "CURRENT_TEST_DIR=${CMAKE_CURRENT_BINARY_DIR}"
                  LIBS        eckit )

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tmp/foo)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/1)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/2)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/2/1)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/bar)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/baz)

=== eckit/tests/geometry/CMakeLists.txt ===
ecbuild_add_test(
    TARGET    eckit_test_geometry_kdtree
    LIBS      eckit_geometry
    SOURCES   test_kdtree.cc
    )

ecbuild_add_test(
    TARGET    eckit_test_geometry_sphere
    LIBS      eckit_geometry
    SOURCES   test_sphere.cc
    )

=== eckit/tests/linalg/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

ecbuild_add_test( TARGET   eckit_test_linalg_factory
                  ARGS     --log_level=message
                  SOURCES  test_la_factory.cc
                  LIBS     eckit_linalg )

ecbuild_add_test( TARGET   eckit_test_linalg_linalg
                  ARGS     --log_level=message
                  SOURCES  test_la_linalg.cc util.h
                  LIBS     eckit_linalg )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_armadillo
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_ARMADILLO
                  ARGS       --log_level=message -linearAlgebraBackend armadillo )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET     eckit_test_linalg_linalg_cuda
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_CUDA
                  ARGS       --log_level=message --catch_system_errors=no -linearAlgebraBackend cuda )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_eigen
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_EIGEN
                  ARGS       --log_level=message -linearAlgebraBackend eigen )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_mkl
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_MKL
                  ARGS       --log_level=message -linearAlgebraBackend mkl )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_viennacl
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_VIENNACL
                  ARGS       --log_level=message -linearAlgebraBackend viennacl )

ecbuild_add_test( TARGET   eckit_test_linalg_sparse
                  ARGS     --log_level=message
                  SOURCES  test_la_sparse.cc util.h
                  LIBS     eckit_linalg )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_armadillo
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_ARMADILLO
                  ARGS       --log_level=message -linearAlgebraBackend armadillo )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET     eckit_test_linalg_sparse_cuda
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_CUDA
                  ARGS       --log_level=message --catch_system_errors=no -linearAlgebraBackend cuda )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_eigen
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_EIGEN
                  ARGS       --log_level=message -linearAlgebraBackend eigen )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_mkl
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_MKL
                  ARGS       --log_level=message -linearAlgebraBackend mkl )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_viennacl
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_VIENNACL
                  ARGS       --log_level=message -linearAlgebraBackend viennacl )

ecbuild_add_test( TARGET   eckit_test_linalg_streaming
                  ARGS     --log_level=message
                  SOURCES  test_la_streaming.cc util.h
                  LIBS     eckit_linalg )

=== eckit/src/eckit/geometry/CMakeLists.txt ===
list( APPEND eckit_geometry_srcs
EllipsoidOfRevolution.cc
EllipsoidOfRevolution.h
KPoint.h
Point2.cc
Point2.h
Point3.cc
Point3.h
Sphere.cc
Sphere.h
SphereT.h
UnitSphere.h
)

ecbuild_add_library(TARGET eckit_geometry
					INSTALL_HEADERS ALL
					HEADER_DESTINATION
						${INSTALL_INCLUDE_DIR}/eckit/geometry
					SOURCES
						${eckit_geometry_srcs}
					LIBS
						eckit  )

=== eckit/src/eckit/linalg/CMakeLists.txt ===
list( APPEND eckit_la_srcs
types.h
LinearAlgebra.cc
LinearAlgebra.h
LinearAlgebraArmadillo.cc
LinearAlgebraArmadillo.h
LinearAlgebraCUDA.cc
LinearAlgebraCUDA.h
LinearAlgebraEigen.cc
LinearAlgebraEigen.h
LinearAlgebraGeneric.cc
LinearAlgebraGeneric.h
LinearAlgebraMKL.cc
LinearAlgebraMKL.h
LinearAlgebraViennaCL.cc
LinearAlgebraViennaCL.h
Matrix.cc
Matrix.h
SparseMatrix.cc
SparseMatrix.h
Triplet.cc
Triplet.h
Vector.cc
Vector.h
)

ecbuild_add_library( TARGET             eckit_linalg
                     INSTALL_HEADERS    ALL
                     HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/linalg
                     SOURCES            ${eckit_la_srcs}
                     INCLUDES           "${ARMADILLO_INCLUDE_DIRS}"
                                        "${CUDA_INCLUDE_DIRS}"
                                        "${MKL_INCLUDE_DIRS}"
                                        "${VIENNACL_INCLUDE_DIRS}"
                     LIBS               eckit
                                        "${ARMADILLO_LIBRARIES}"
                                        "${CUDA_LIBRARIES}" "${CUDA_cusparse_LIBRARY}"
                                        "${MKL_LIBRARIES}" )

if (CUDA_FOUND)
cuda_add_cublas_to_target( eckit_linalg )
endif()

=== eckit/src/experimental/sandbox/CMakeLists.txt ===
ecbuild_add_executable( TARGET sandbox_pool NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES pool.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_net NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES net.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_pipe NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES pipe.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_tcp_client NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES tcp_client.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_tcp_server NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES tcp_server.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_tcp_server_threaded NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES tcp_server_threaded.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_tcp_server_forked NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES tcp_server_forked.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET sandbox_arg NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES arg.cc
                        LIBS eckit_cmd )

ecbuild_add_executable( TARGET  sandbox_tcp_client_json NOINSTALL
                        CONDITION ENABLE_SANDBOX
                        SOURCES tcp_client_json.cc
                        LIBS eckit )

=== debian/changelog ===
odb-api (0.18.0-5) unstable; urgency=medium

  * Fix broken symlinks in /usr/bin. Closes: #904511
  * Update URLs in d/watch

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 26 Jul 2018 12:14:04 +0100

odb-api (0.18.0-4) unstable; urgency=medium

  * Add libc6-dev-mips32 build-dep for mips64el to fix FTBFS

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 13 Jul 2018 21:09:27 +0100

odb-api (0.18.0-3) unstable; urgency=medium

  * qtar conflicts with hxtools. Rename to ecmwf_qtar. Closes: #903445
  * rename qtar -> ecmwf_qtar in cmake files
  * Fix paths in odb-targets-release.cmake
  * Standards-Version: 4.1.5
  * Include statically linked libs
  * Add Depends: ${misc:Depends} to -data pkg

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 13 Jul 2018 06:43:17 +0100

odb-api (0.18.0-2) unstable; urgency=medium

  * Enable ODB, ODB_MPI (for metview)
  * Disable AIO on Hurd - can't find aio_suspend, etc.
  * Enable tests (ignore test failures for now)
  * Set OpenMPI oversuscribe on in d/rules for tests
  * Add libodb-api-data for shared ODB data

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 04 Jul 2018 01:16:39 +0100

odb-api (0.18.0-1) unstable; urgency=medium

  * New upstream release
    - Update py3-port.patch for python3.7
    - Build against python3.6, python3.7
    - refresh unique_ptr.patch
  * Remove obsolete patches:
    - swap_decl.patch
    - unsigned_long_on_32bit.patch
  * Add -DENABLE_ODB_API_SERVER_SIDE=ON
  * Enable OpenMP threading
  * Disable VIENNACL (Experimental)

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 02 Jul 2018 17:26:55 +0100

odb-api (0.17.6-4) unstable; urgency=medium

  * Build against gfortran-8.
  * Use dh-fortran-mod to capture fortran mod file version`

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 May 2018 10:08:24 +0100

odb-api (0.17.6-3) unstable; urgency=medium

  * Standards-Version: 4.1.4; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 15 Apr 2018 07:37:14 +0100

=== debian/control ===
Source: odb-api
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>=10),
 dh-python,
 dh-fortran-mod,
 gfortran-8, 
 flex,
 bison,
 cmake (>= 2.8.11), 
 libopenjp2-7-dev,
 libboost-dev (>= 1.47.0), libboost-test-dev, 
 libssl-dev,
 libemos-dev,
 libncurses5-dev,
 libnetcdf-cxx-legacy-dev,
 libeccodes-tools,
 chrpath,
 doxygen,
 swig,
 libeccodes-dev (>= 2.5.0),
 mpi-default-dev,
 libeigen3-dev,
 libviennacl-dev,
 libarmadillo-dev,
 python3-all-dev,
 libnetcdf-dev,
 libc6-dev-mips32 [mips64el]
Standards-Version: 4.1.5
Homepage: https://software.ecmwf.int/wiki/display/ODBAPI
Vcs-Browser: https://salsa.debian.org:/science-team/odb-api.git
Vcs-Git: https://salsa.debian.org:/science-team/odb-api.git

Package: libodb-api-0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libodb-api-data
Description: Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 ODB API works with data formats used in the ECMWF observational feedback
 archive.  Development of ODB API has been partially funded by the 
 UK Met Office.

Package: libodb-api-bin
Section: libs
Architecture: any
Multi-Arch: foreign
Depends: libodb-api-0d ( = ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 ksh | mksh | pdksh | zsh
Description: Tools for the Observational Data Processing (ODB) API
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides tools for ODB handling.

Package: libodb-api-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data used by ECMWF Observational Data Processing (ODB) 
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. 
 .
 This package contains data used by ODB tools.
 
Package: libodb-api-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libodb-api-0d ( = ${binary:Version}), ${misc:Depends}, libodb-api-bin
Recommends: pkg-config, gfortran
Description: Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides shared libraries and headers.

Package: python3-odb-api
Section: python
Architecture: any
Multi-Arch: same
Depends: libodb-api-0d ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Description: Python Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides the Python wrappers to the ODB API.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake --with=python3,fortran_mod

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ARCH:=$(shell dpkg --print-architecture)
AUTOGENERATED:= libodb-api-0d.install libodb-api-dev.install libodb-api-dev.links
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
DESTDIR:=$(shell pwd)/debian/tmp

ifeq ($(ARCH), hurd-i386)
  AIO:= -DENABLE_AIO=OFF
endif

# hard-code gfortran-8 for transition
export FC:=gfortran-8

# For MPI tests
export OMPI_MCA_rmaps_base_oversubscribe=1

PY3DEFAULT:=$(shell py3versions --default)
PY3OTHERS:=python3.7

CMAKE_DIR_ECKIT:=debian/tmp/usr/share/eckit/cmake
CMAKE_DIR_ODBAPI:=debian/tmp/usr/share/odb_api/cmake
CMAKE_DIR_ODB:=debian/tmp/usr/share/odb/cmake
INC_DIR:=debian/tmp/usr/include

CMAKE_CFLAGS:= -DDISABLE_AIO=ON \
		-DCMAKE_BUILD_TYPE=Release \
		-DDISABLE_OS_CHECK=ON \
		-DBUILD_SHARED_LIBS=ON \
		-DENABLE_EIGEN=ON \
		-DENABLE_NETCDF=ON \
		-DENABLE_FORTRAN=ON \
		-DENABLE_PYTHON=ON \
		-DENABLE_OMP=ON \
		-DENABLE_ODB=ON \
		-DENABLE_ODB_MPI=ON \
		-DENABLE_ODB_API_SERVER_SIDE=ON 

#		-DENABLE_ODB_EMOS=ON 

override_dh_auto_clean:
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	dh_auto_clean

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
	done
	dh_auto_configure --  ${CMAKE_CFLAGS} -DPYTHON_EXECUTABLE=/usr/bin/${PY3DEFAULT}

override_dh_auto_test:
	@echo "Skipping tests; need to disable downloads"
	dh_auto_test ||  echo "Ignoring test failures" 

override_dh_auto_install:
	cd obj-* && $(MAKE) install DESTDIR=$(DESTDIR) 
	mv debian/tmp/usr/lib/python2.7 debian/tmp/usr/lib/$(PY3DEFAULT)
	dh_auto_configure --  ${CMAKE_CFLAGS} -DPYTHON_EXECUTABLE=/usr/bin/${PY3OTHERS}
	cd obj-* && $(MAKE) install DESTDIR=$(DESTDIR) 
	mv debian/tmp/usr/lib/python2.7 debian/tmp/usr/lib/$(PY3OTHERS)
	# Install done (multiple times) in dh_auto_build
	dh_auto_install	
	for d in debian/tmp/usr/bin/* ; do \
		( chrpath -d $$d || echo "Ignoring non-ELF file errors") ; done
	chrpath -d debian/tmp/usr/lib/*.so*
	# Fix broken paths 
	cat ${CMAKE_DIR_ECKIT}/eckit-targets-release.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR_ECKIT}/tmp
	mv ${CMAKE_DIR_ECKIT}/tmp ${CMAKE_DIR_ECKIT}/eckit-targets-release.cmake
	cat ${CMAKE_DIR_ODBAPI}/odb_api-targets-release.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 's%"/usr/bin/odb"%"/usr/bin/ecmwf_odb"%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR_ODBAPI}/tmp
	mv ${CMAKE_DIR_ODBAPI}/tmp ${CMAKE_DIR_ODBAPI}/odb_api-targets-release.cmake
	cat ${CMAKE_DIR_ODB}/odb-targets.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 's%"/usr/bin/qtar"%"/usr/bin/ecmwf_qtar"%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR_ODB}/tmp
	mv ${CMAKE_DIR_ODB}/tmp ${CMAKE_DIR_ODB}/odb-targets.cmake
	cat ${CMAKE_DIR_ODB}/odb-targets-release.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 's%"/usr/bin/qtar"%"/usr/bin/ecmwf_qtar"%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR_ODB}/tmp
	mv ${CMAKE_DIR_ODB}/tmp ${CMAKE_DIR_ODB}/odb-targets-release.cmake
	# Sanitise paths for bit reproducibility
	cat ${CMAKE_DIR_ODBAPI}/odb_api-config.cmake | \
		sed -e 's%${CURDIR}%/build/odb-api%g' > ${CMAKE_DIR_ODBAPI}/tmp
	mv ${CMAKE_DIR_ODBAPI}/tmp ${CMAKE_DIR_ODBAPI}/odb_api-config.cmake
	# Delete files that break reproducibility, and refs from include files
	rm -f ${INC_DIR}/odb_api/odb_api_ecbuild_config.h \
		${INC_DIR}/eckit/eckit_ecbuild_config.h   \
		${INC_DIR}/metkit/metkit_ecbuild_config.h 
	grep -v odb_api_ecbuild_config.h ${INC_DIR}/odb_api/odb_api_config.h | \
		grep -v ODB_API_BINARY_DIR > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/odb_api/odb_api_config.h
	grep -v eckit_ecbuild_config.h ${INC_DIR}/eckit/eckit_config.h | \
		grep -v ECKIT_BUILD_DIR > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/eckit/eckit_config.h
	grep -v metkit_ecbuildconfig.h ${INC_DIR}/metkit/metkit_config.h > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/metkit/metkit_config.h
	# Avoid conflict with different odb ( #880890) 
	mv debian/tmp/usr/bin/odb	debian/tmp/usr/bin/ecmwf_odb
	# #903445: qtar conflicts with hxtools
	mv debian/tmp/usr/bin/qtar	debian/tmp/usr/bin/ecmwf_qtar
